'*******************************************************************************
'                               ZV Blinker
'
' Marcus Pool
'
' Version: 1.1
'
' geschrieben am 14.03.2003
'
' ZV auf    = PB 2 - Pin 7
' ZV zu     = PB 0 - Pin 5
' Interrupt = PB 1 - Pin 6
'
' Wenn die ZV auf oder zu geht wird ein Interrupts ausgelst, welcher dann die
' passende Sequenz der Blinker und eventuell Hupe steuert.
' Es wird ein positiver Impuls an den Eingngen bentigt.
'
'*******************************************************************************

$crystal = 1000000                                          'internal Oszillator
$regfile = "at22def.dat"

Config Pinb.0 = Input                                       'ZV auf
Config Pinb.2 = Input                                       'ZV zu
Config Pinb.3 = Output                                      'Blinker
Config Pinb.4 = Output                                      'Hupe
Config Int0 = Rising


Enable Interrupts
Enable Int0

On Int0 Wach

Reset Portb.3                                               'setzte Ausgang auf low
Reset Portb.4                                               'setzte Ausgang auf low

Schlafen:
   Idle                                                     'wenn nichts luft dann Stromsparmodus
Goto Schlafen

Wach:                                                       'Interrups Routine
   If Pinb.0 = 1 Then Goto Auf                              'ZV auf?
   If Pinb.2 = 1 Then Goto Zu                               ' ZV zu?
Return

Auf:                                                        ' 2 mal blinken und hupen
   Waitms 50
   Set Portb.3
   Set Portb.4                                              'Hupe fr 100 ms an
   Waitms 100
   Reset Portb.4                                            'Hupe wieder aus
   Waitms 400
   Reset Portb.3
   Waitms 500
   Set Portb.3
   Set Portb.4                                              ' Hupe fr 100 ms an
   Waitms 100
   Reset Portb.4                                            ' Hupe wieder aus
   Waitms 400
   Reset Portb.3
   Waitms 500
Return

Zu:                                                         ' 1 mal blinken uind hupen
   Waitms 50
   Set Portb.3
   Set Portb.4                                              ' Hupe fr 100 ms an
   Waitms 100
   Reset Portb.4                                            ' Hupe wieder aus
   Waitms 400
   Reset Portb.3
   Waitms 500
Return